
module.exports = function (){

  var master = [].slice.call(arguments)

  function F (value) {
    if(!(this instanceof F)) return new F(value)
    this.value = value
    this._go = function (name,func,args) {
        args.unshift(this.value)
        this.value = func.apply(null,args)
      return this
    }
  }

  function _F (name,func,args,last) {
    if(!(this instanceof _F)) return new _F(name,func,args,last)

    this._go = function (name,func,args) {
      return new _F(name,func,args,this)
    }

    this.value = function (value){
      args.unshift(last && last.value ? last.value(value) : value)
      return func.apply(null,args)
    }
  }

  F._go = function (name,func,args){
    return new _F (name,func,args)
  }

  var prototype = _F.prototype = F.prototype = F

  master.forEach(function (e){
    Object.keys(e).forEach(function (name){
      prototype[name] = function (){
        var args = [].slice.call(arguments)
        return this._go(name, e[name], args, this.last)
      }
    })
  })

  return F
}