
var f = require('../f')(require('underscore'))
  , assert = require('assert')

exports ['f(x).func()'] = function (){

  assert.equal(f(8).identity().value,8)
  assert.deepEqual(f([1,2,3]).map(function (x){return x * 2}).value,[2,4,6])  
}

exports ['f(x).func1().func2()'] = function (){

  assert.equal(f(8).identity().identity().value,8)
  assert.deepEqual(
    f([1,2,3])
    .map(function (x){return x * 2})
    .map(function (x){return x * 2})
    .value
    ,
    [4,8,12])
}

exports ['(f.func1())(x)'] = function (){

  assert.equal((f.identity().value)(8),8)
  assert.deepEqual(
    f.map(function (x){return x * 2}).value([1,2,3])
    ,[2,4,6])
}

exports ['(f.func1().func2())(x)'] = function (){

  assert.equal((f.identity().identity().value)(8),8)
  assert.deepEqual(
    f.map(function (x){return x * 2})
    .map(function (x){return x * 2}).value([1,2,3])
    ,[4,8,12])
}
